/*****************************************************************************
 * ScribeEngine - Open Source Blog Software                                  *
 * ------------------------------------------------------------------------- *
 * Copyright (c) 2010 Raoul Snyman                                           *
 * ------------------------------------------------------------------------- *
 * This program is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU General Public License as published by the     *
 * Free Software Foundation; version 2 of the License.                       *
 *                                                                           *
 * This program is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General  *
 * Public License for more details.                                          *
 *                                                                           *
 * You should have received a copy of the GNU General Public License along   *
 * with this program; if not, write to the Free Software Foundation, Inc.,   *
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA                     *
 *****************************************************************************/

ScribeEngine.Namespace.create("ScribeEngine.Media", {
    closeWindow: function ()
    {
        window.close();
    },
    newDirectory: function ()
    {
        var dirname = prompt("New Directory:", "directory");
    },
    getFiles: function (event)
    {
        var tree = jQuery.jstree._focused();
        var path = tree.get_path(ScribeEngine.Events.getElement(event));
        $.getJSON(
            '/media/get-files',
            {"path": path.toString()},
            function (data, textStatus) {
                $("#file-list > ul").html("");
                $.each(data.results, function () {
                    var file = this;
                    if (file.name.length > 15)
                    {
                        file.name = file.name.substr(0, 12) + "...";
                    }
                    $("#file-list > ul").append(
                        $("<li>")
                            .append(
                                $("<a>").attr("href", "#").attr("class", "file")
                                    .html("<img src=\""+ file.type +"\" />")
                            )
                            .append(
                                $("<a>").attr("href", "#").attr("class", "caption")
                                    .attr("title", file.name).text(file.name)
                            )
                    );
                });
            }
        );
        return false;
    },
    selectFile: function (e)
    {
        var li = ScribeEngine.Events.getElement(e).parent();
        if (!li.is("li"))
        {
            li = li.parent();
        }
        li.parent().children("li").children(".selected").removeClass("selected");
        li.children("a").addClass("selected").blur();
        return false;
    }
});

ScribeEngine.Events.load(function () {
    ScribeEngine.Events.click("#new-directory", ScribeEngine.Media.newDirectory);
    ScribeEngine.Events.click("#file-select", ScribeEngine.Media.closeWindow);
    ScribeEngine.Events.liveClick("#file-list > ul > li > a", ScribeEngine.Media.selectFile);
});
